/*falta renovar el problema ahora es la copiea del SCDual es decir vien que M1 falta los Q,
 */

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <cstring>
#include <vector>
#include "math.h"
#include "BlockIP.h"
#include "ExceptionBlockIP.h"
using namespace std;

//functions
void createBalancePfacilityDual(int supplyN, int Pfacility, int ClientN, int *iN1, int *jN1, int *aN1, int numVarx);
void createDemandClientNDual(int supplyN, int Pfacility, int ClientN, int *iN1, int *jN1, int *aN1, int numVarx, int numVarzS1);
void createCapacitySPyDual(int *iN2y, int *jN2y, int *aN2y, int numVary);
void createCapacitySPxHDual(int supplyN, int Pfacility, int ClientN, int *iN2x, int *jN2x, int *aN2x, int numVarx, int nozeroN2x); // (x) from capacity constraints 
void createInvestmentSP(double *c1, int numVary); //investment cost for building
void createShortageC(int ClientN, double *z1); //the unit shortage cost at each distribution center
void createTransportationSPyPC(int supplyN, int Pfacility, double *qd, int numVarx); //transportation cost from S to P and P to C
void createDualCost(int supplyN, int Pfacility, int ClientN, int numBlocks, double *c1, double *z1, double *qd, double **Q, int numVary, int numVarx, int numVarz, int numVarBlock);// Q cost primal
void createDemandD(int ClientN, int numBlocks, double **D);// D rhs primal

//main
int main(int argc, char *argv[]) {
  clock_t t0,t1;

  if (argc < 4 ){   //|| argc % 2 != 0) {
    cerr << "usage: SCDual need the <number of Supplies>  <number Pfailities> <number of clients> and <number of blocks>  "<< endl
         << "example: ./SCDual 4 4 3 3  \n"
	 << "Optinos: DDDD "
         << endl;

   // write_options();
    exit(-1);
  }


cout<<"INICIA Dual Quadratico"<<endl;
for(int i = 0; i < argc; i++) 
      cout << argv[i] << " "; 
   cout << endl; 

 int supplyN = atoi(argv[1]); //number of supply nodes
 int Pfacility = atoi(argv[2]); //number of the processing facilities
 int ClientN = atoi(argv[3]); //number of clients
 int numBlocks = atoi(argv[4]);  // number of blocks (scenarios 1ºstage+2ºscenarios)

 int numVary=supplyN+Pfacility;  // number of variables y -to build or not-
 int numVarx = supplyN*Pfacility+Pfacility*ClientN; // number of variables x  -arcs- numArcs
 int numVarzS1= ClientN; //shorfall of product (without slack)
 int nozeroN1=numVarx+(Pfacility*ClientN)+numVarzS1; //number of non-zeros of 1º Block with shorfall z   
 int nozeroN2x=numVarx; //number of non-zeros of 1º Block con slacks  *withour 8slacks)  
 int numVarz = numVarzS1 + numVary + numVarx; // number of variables z+ slack(3demanda+8capacidadPyS+U) 
 int numVarBlock= numVary+ (2*numVarx) + numVarz; //with splitting 

 int numConstP1= Pfacility + ClientN; // number of constraints for 1º-block primal  
 int numLConst=numVary+numVarx;
 int numVarxz=numVarx + numVarz;
 int nozeroN2 = (3*numVarx)+ClientN;
 int nozeroN = nozeroN1+nozeroN2;
 int numVarBlockDual = numConstP1+numVary+numVarx*2+ClientN;

//Q from formulation Quadratic 
 int numQsim=((numVarx+ClientN)*numBlocks)+numVarx+numVary; //numero de x² 
 int numQsimN=numVarx+ClientN; //numero de x²---for N 
 int numQsimL=numVarx+numVary; //numero de x²---for L


 int *iN1=NULL, *jN1=NULL, *aN1=NULL;
 int *iN2y=NULL, *jN2y=NULL, *aN2y=NULL;
 int *iN2x=NULL, *jN2x=NULL, *aN2x=NULL;
 double *c1=NULL, *z1=NULL, *qd=NULL;
 double *Qsim=NULL; // for Quadratic cost
 double **Q;
 double **D; //demand
 

  srand(50); 

cout<<"numBlocks= "<<numBlocks<<endl;
cout<<"supplyN= "<<supplyN<<endl;
cout<<"Pfacility= "<<Pfacility<<endl;
cout<<"ClientN= "<<ClientN<<endl;
cout<<"numVarx= "<<numVarx<<endl;

cout<<"numVary= "<<numVary<<endl;
cout<<"1stStage= "<<numVarx+numVary<<endl;
cout<<"numVarBlock from primal= "<<numVarBlock<<endl;
cout<<"numVarz= "<<numVarz<<endl;

  iN1=new int[nozeroN1];
  jN1=new int[nozeroN1];
  aN1=new int[nozeroN1];
  iN2y=new int[numVary];
  jN2y=new int[numVary];
  aN2y=new int[numVary];
  iN2x=new int[nozeroN2x];
  jN2x=new int[nozeroN2x];
  aN2x=new int[nozeroN2x];
  c1=new double[numVary];
  z1=new double[ClientN];
  qd=new double[numVarx];
  Qsim=new double[numQsim];//inicializas Qsim

//inicializas Q
Q = new double* [numBlocks];
for(int b=0; b<numBlocks; b++){ 
	Q[b] = new double[numVarBlock]; 
}

for(int b=0; b<numBlocks; b++){ 
	for(int auxi=0; auxi<numVarBlock; auxi++){
 		Q[b][auxi] = 0.0; 
	}
}

//inicializas D
D = new double* [numBlocks];
for(int b=0; b<numBlocks; b++){ 
 D[b] = new double[ClientN];
  for(int auxi=0; auxi<ClientN; auxi++){
   D[b][auxi]=0;
  }//for
}//for


  createBalancePfacilityDual(supplyN, Pfacility, ClientN, iN1, jN1, aN1, numVarx);
  createDemandClientNDual(supplyN, Pfacility, ClientN, iN1, jN1, aN1, numVarx, numVarzS1);
  createCapacitySPyDual(iN2y, jN2y, aN2y, numVary);
  createCapacitySPxHDual(supplyN, Pfacility, ClientN, iN2x, jN2x, aN2x, numVarx, nozeroN2x);
  createInvestmentSP(c1, numVary); 
  createShortageC(ClientN, z1); 
  createTransportationSPyPC(supplyN, Pfacility, qd, numVarx);
  createDualCost(supplyN, Pfacility, ClientN, numBlocks, c1, z1, qd, Q, numVary, numVarx, numVarz, numVarBlock);
  createDemandD(ClientN, numBlocks, D);



  cout<<" numQsim = "<<numQsim<<endl;
  cout<<" numQsimN = "<<numQsimN<<endl;
  cout<<" numQsimL = "<<numQsimL<<endl;


//inicializo Q
//  double qQsim[numQsim];// cambioQ

	for (int i=0; i<(numBlocks*(numVarx+ClientN))+numVarx+numVary; i++){
		Qsim[i]=0;///cambioQ
	}//for

// asigne cost for Q =qcost
  int qj = 0,  qjj= numVarx+numVary, auxqj=0, auxqjj=0; // Q[j][jj] -> j blocks
	for (int i=0; i<((numVarx+ClientN)*numBlocks)+numVarx+numVary; i++){
		if(i<((numVarx+ClientN)*numBlocks)){	 
			Qsim[i] =2*(1.0/(double)numBlocks);// cambioQ
		//cout<<"qcost["<<i<<"]= "<<qcost[i]<<endl;
		}
		else{
				Qsim[i] =2;// cambioQ
				auxqjj++;
			}//else
		if(i==(numVarx+ClientN)*(qj+1)-1){ 
			qj++;
			qjj=numVarx+numVary-1;
		}//if
		qjj++;	
	} //for  

// for check
//	for (int i=0; i<(numBlocks*(numVarx+ClientN))+numVarx+numVary; i++){
//		cout<<"Qsim["<<i<<"]= "<<Qsim[i]<<endl;// cambioQ// cambioQ
//	}//for

//cout<<" ninicio= "<< numConstP1 + numVary + numVarx<<endl;
//cout<<" ninicio= "<< numConstP1 <<endl;
//cout<<" arranca= "<<nozeroN1+nozeroN2x+numVarx*2+ClientN<<endl;
//cout<<" termina= "<<nozeroN1+nozeroN2x+numVarx*2+ClientN + numQsimN<<endl;
//cout<<" col= "<<numConstP1 + numVary + numVarx + numQsimN<<endl;

  MatrixBlockIP *N =  NULL; 
  N = new MatrixBlockIP[numBlocks+2];//mas uno por las M1rest + nuevo Q0 

  //MatrixBlockIP N;   
  int *iW, *jW;
  double *WN; 
  int nz_aux;

//para Q first stage y<=1 and u<=M  M1rest
N[0].create_general_matrix_format_ija(0,numVary+numVarx, 0, iW, jW, WN);

for(int b=1; b<=numBlocks; b++){ 
N[b].create_general_matrix_format_ija(numVarx+ClientN, numVarBlockDual + numQsimN, nozeroN + numQsimN, iW, jW, WN);
		int k = 0, r = 0, s = 0, ss = 0, sq = 0;
		for (int i = 0; i < nozeroN+ numQsimN; ++i) {
			if (i<nozeroN1){  
				iW[i] = iN1[i];
				jW[i] = jN1[i];
				WN[i] = aN1[i];
				//cout<<"i= "<<iW[i]<<"  j= "<<jW[i]<<" - "<<" = Wa["<<i<<"]= "<<WN[i]<<endl; 
			}else{          
				if(i<nozeroN1+nozeroN2x){ 
					iW[i] = iN2x[k];
					jW[i] = jN2x[k];
					WN[i] = -aN2x[k];
		//cout<<"i= "<<iW[i]<<" j= "<<jW[i]<<" = a["<<i<<"]= "<<WN[i]<<endl; 
					k++;
				}else{
					if(i<nozeroN1+nozeroN2x+numVarx){ // x de las U's
						iW[i] = s ;
						jW[i] = s + numConstP1 + numVary;
						WN[i] = -1;
		//cout<<"i= "<<iW[i]<<" j= "<<jW[i]<<" = a["<<i<<"]= "<<WN[i]<<endl; 
						s++;
					}else{  
						if(i<nozeroN1+nozeroN2x+numVarx*2+ClientN){ // Dual slacks 
							iW[i] = ss;
							jW[i] = ss + numConstP1 + numVary + numVarx; //***numVarU
							WN[i] = 1;
	//	cout<<"i= "<<iW[i]<<" j= "<<jW[i]<<" = a["<<i<<"]= "<<WN[i]<<endl; 
							ss++;
						}//if
						else{	//nuevo Q
							if(i<nozeroN1+nozeroN2x+numVarx*2+ClientN + numQsimN){ // Dual slacks 
							iW[i] = sq;
							jW[i] = sq + numConstP1 + numVary + numVarx + numQsimN; //***numVarU
							WN[i] = -Qsim[sq];// cambioQ
		//cout<<"i= "<<iW[i]<<" j= "<<jW[i]<<" = a["<<i<<"]= "<<WN[i]<<endl; 
							sq++;
						}//if
						}//nuevo else Q
					}
				}
			}     
		}//for 
}//for b
 
//para Q first stage
N[numBlocks+1].create_general_matrix_format_ija(0,numQsimL, 0, iW, jW, WN);

  MatrixBlockIP *L =  NULL; 
  L = new MatrixBlockIP[numBlocks+2];
  //MatrixBlockIP L;
  int *iL, *jL;
  double *NL;

//int sqq = numQsimN*numBlocks;
L[0].create_general_matrix_format_ija(numVary+numVarx, numVary+numVarx,numVary+numVarx , iL, jL, NL);
	for (int i = 0; i < (numVary+numVarx); ++i) { 
   		iL[i] = i;
    	jL[i] = i;
		NL[i] = -1;
		//cout<<"i= "<<iL[i]<<" j= "<<jL[i]<<" = a["<<i<<"]= "<<NL[i]<<endl; 
	}//for   

for(int b=1; b<=numBlocks; b++){ 
L[b].create_general_matrix_format_ija(numVary+numVarx, numVarBlockDual+ numQsimN,numVary+numVarx , iL, jL, NL);
//L.create_general_matrix_format_ija(numVary+numVarx, numVarBlockDual,numVary+numVarx , iL, jL, NL); 
	for (int i = 0; i < (numVary+numVarx); ++i) { 
   		iL[i] = i;
    	jL[i] = numConstP1 + i;
		if(i < numVary ) {
			NL[i] = aN2y[i];
  		}
		else{
			NL[i] = 1;//original(-1)
		}
		//cout<<"i= "<<iL[i]<<" j= "<<jL[i]<<" = a["<<i<<"]= "<<NL[i]<<endl; 
	}//for   
}//for b


int sqq = numQsimN*numBlocks;
L[numBlocks+1].create_general_matrix_format_ija(numVary+numVarx, numQsimL,numVary+numVarx , iL, jL, NL);
	for (int i = 0; i < (numVary+numVarx); ++i) { 
   		iL[i] = i;
    	jL[i] = i;
		NL[i] = -Qsim[sqq];// cambioQ
		//cout<<"i= "<<iL[i]<<" j= "<<jL[i]<<" = a["<<i<<"]= "<<NL[i]<<endl; 
	}//for   


BlockIP bip; // declare BlockIP problem 
    
   double *cost=NULL, *qcost=NULL, *lb=NULL, *ub=NULL, *lhs=NULL, *rhs=NULL; 

 // creation of BlockIP problem
  bip.create_problem(BlockIP::QUADRATIC, cost, qcost, NULL, NULL, lb, ub, lhs, rhs, numBlocks+2, false, N, false , L);

 // fill arrays of data for problem -cost  numVarBlockDual
    for (int i=0; i<numVary+numVarx; i++){
		if(i<numVary){
			cost[i]=1; //built or not //Max = -Min + var <=0
		}else{
			cost[i]=1.0e+6;//M maximum for capacity of arcs //Max = -Min + var <=0
		}//else
	}//for

// for check
//for(int i=0; i<numVary+numVarx; i++){
//	cout<<" cost["<<i<<"]= "<<cost[i]<<endl;
//}

  int aux_cost = 0; // D[aux_rhs][aux_rhs2]-->aux_rhs = blocks 
  int aux_cost2= 0;
  int cost3= 0; //constraints per block
  int cost4= 0; //new i
	for (int i=numVary+numVarx; i<(((numVarBlockDual+numQsimN)*numBlocks)+(numVary+numVarx)); i++){ 
		cost[i]=0;
		if(cost3>=Pfacility && cost3<(Pfacility + ClientN)){
			cost[i] = D[aux_cost][aux_cost2]*(-1);//Max = -Min
			//cout<< "i= "<<i<<" =D["<<aux_cost<<"]["<<aux_cost2<<"]="<<D[aux_cost][aux_cost2] <<endl;
			aux_cost2++;
		}
		if(cost4==((numVarBlockDual+numQsimN)*(aux_cost+1))-1){ 
			aux_cost++;
			aux_cost2=0;
			cost3=-1;
		}
		cost3++;
		cost4++;		
	}  //for

// for check
//for(int i=numVary+numVarx; i<((numVarBlockDual*numBlocks)+(numVary+numVarx)); i++){ 
//	cout<<" cost["<<i<<"]= "<<cost[i]<<endl;
//}

//holguras y Q0 cost
	for(int i=((numVarBlockDual+numQsimN)*numBlocks)+numVary+numVarx; i<(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary*2+numVarx*2; i++){ 
		cost[i]=0;	
	}

/* 
 //for check
int iAux2cost = -1;
for (int b=0; b<numBlocks+1; b++){
 for (int i = 0; i < numVarBlockDual+numVary+numVarx; ++i) { 
     cout<< cost[++iAux2cost] <<"\t";
 }cout<< endl;
}
*/

// -qcost 
 for (int i=0; i<numVary+numVarx; i++){
 	qcost[i]=0;	
//cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;
 }//for 1º bloque N[0]

  int aux_qcost = 0; // D[aux_rhs][aux_rhs2]-->aux_rhs = blocks 
  int aux_qcost2= -1;
  int qcost3= 0; 
	for (int i=numVary+numVarx; i<((numVarBlockDual+numQsimN)*numBlocks)+numVary+numVarx; i++){ //los bloques iguales
		qcost[i]=0;
		if(qcost3>=numVarBlockDual && qcost3<numVarBlockDual+numQsimN){
			qcost[i]=Qsim[++aux_qcost2];// cambioQ
			//cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;
			//cout<<"qcost3 = "<<qcost3<<endl;
		}
		if(qcost3==((numVarBlockDual+numQsimN)-1)){   // *(aux_qcost+1))-1){ 
			aux_qcost++;
			qcost3=-1;
		}
		qcost3++;		
	}  //for

//for check
//	for(int i=numVary+numVarx; i<((numVarBlockDual+numQsimN)*numBlocks)+numVary+numVarx; i++){ 
//		cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;	
//	}
 
//bloque nulo Qy1
  int aux_qcost3= numQsimN*numBlocks-1;
	for(int i=(numVarBlockDual+numQsimN)*numBlocks+numVary+numVarx; i<(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx; i++){ 
		qcost[i]=Qsim[++aux_qcost3];// cambioQ
		//cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;	
		//cout<<"Qsim["<<aux_qcost3<<"] = "<<Qsim[aux_qcost3]<<endl;// cambioQ// cambioQ	
	}
//for check
//	for(int i=(numVarBlockDual+numQsimN)*numBlocks+numVary+numVarx; i<(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx; i++){ 
//	cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;	
//	}



 //holguras qcost
	for(int i=(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx; i<(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx+numVary+numVarx; i++){ 
		qcost[i]=0;	
	}

//for check
//	for(int i=(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx; i<(numVarBlockDual+numQsimN)*numBlocks+numQsimL+numVary+numVarx+numVary+numVarx; i++){ 
//		cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;	
//	}
//for check
//	for(int i=0; i<(numVarBlockDual+numQsimN)*numBlocks+(numVary+numVarx)*2+numVary+numVarx; i++){ 
//		cout<<"qcost["<<i<<"] = "<<qcost[i]<<endl;	
//	}


//rhs
  int j = 0,  jj= numVarx+numVary, auxjrhs=0, auxjjrhs=0; // Q[j][jj] -> j blocks
	for (int i=0; i<((numVarx+ClientN)*numBlocks)+numVarx+numVary; i++){
		if(i<((numVarx+ClientN)*numBlocks)){	 
			rhs[i] = (Q[j][jj])*(1.0/(double)numBlocks);
		//cout<<"rhs["<<i<<"]= "rhs[i]<<endl;
		}
		else{
				rhs[i] = Q[auxjrhs][auxjjrhs];
				auxjjrhs++;
			}//else
		if(i==(numVarx+ClientN)*(j+1)-1){ 
			j++;
			jj=numVarx+numVary-1;
		}//if
		jj++;	
	} //for  

 //Lower constraint limits
	for (int i=0; i<((numVarx+ClientN)*numBlocks)+numVarx+numVary; i++){
		lhs[i] = rhs[i];
	}//for

//	for (int i=0; i<(numBlocks*(numVarx+ClientN))+numVarx+numVary; i++){
//		cout<<"rhs["<<i<<"]= "<<rhs[i]<<endl;
//	}//for

 // Lower and upper bound for each variable 
    for (int i=0; i<numVary+numVarx; i++){
    	ub[i] = bip.get_inf(); 
		lb[i] =  0;
	}//for

// for check
//for(int i=0; i<numVary+numVarx; i++){
//	cout<<"ub["<<i<<"]= "<<ub[i]<<endl;
//}

  int ii=0, bb=1;
	for (int i=numVary+numVarx; i<(((numVarBlockDual+numQsimN)*numBlocks)+(numVary+numVarx)); i++){ 
		if(ii < Pfacility){ 
			ub[i] = bip.get_inf();//1.0e12;
			lb[i] = -bip.get_inf();
		}else{
			if(ii <Pfacility + ClientN){  
    			ub[i] = bip.get_inf(); 
				lb[i] =  0;
			}else{
				if(ii<Pfacility + ClientN + numVary + numVarx){ 
	   				ub[i] =  bip.get_inf();
					lb[i] = 0;
				}//if
				else{ 
				   	ub[i] = bip.get_inf();
					lb[i] = 0;
				}//else
			}//else
		}//else
		if(ii==((numVarBlockDual+numQsimN)*bb)-1){
			ii=-1;
		}
		ii++;
    }//for

	for(int i=(((numVarBlockDual+numQsimN)*numBlocks)+(numVary+numVarx)); i<(((numVarBlockDual+numQsimN)*numBlocks)+(numVary+numVarx))+numVary+numVarx+numQsimL; i++){ 
		ub[i] = bip.get_inf(); 
		lb[i] = 0;
	}

 //for check
//	for(int i = 0; i < (numVarBlockDual*numBlocks)+numVary+numVarx; i++){
//		cout<< "ub["<<i<<"]= "<<ub[i]<<endl;
//		cout<< "lb["<<i<<"]= "<<lb[i]<<endl;
//	}


//for check
/*
ofstream MatrixDualN("DualNL.xls");
MatrixDualN<<"N total"<<endl;
MatrixDualN<<"True if irowa, icola and a are stored.= "<<N.ija<<endl;
MatrixDualN<<"nozero N= "<<N.nz<<endl;

MatrixDualN<<"irowaN "<<endl;
for(int i=0; i<N.nz;i++){
	MatrixDualN<<N.irowa[i]<<"\t";
}MatrixDualN<<endl;

MatrixDualN<<"icolaN "<<endl;
for(int i=0; i<N.nz;i++){
	MatrixDualN<<N.icola[i]<<"\t";
}MatrixDualN<<endl;

MatrixDualN<<"aN "<<endl;
for(int i=0; i<N.nz;i++){
	MatrixDualN<<N.a[i]<<"\t";
}MatrixDualN<<endl;

MatrixDualN.close();
*/

 //  write problem in BlockIPformat, read problem (freed and created) and solve 
//  cout << endl << "Write block-MPS format" << endl;
  bip.write_mps("SCDQuad");
//  cout << endl << "Write block-matlab format" << endl;
//  bip.write_matlab_format("SCDual2");
//  cout << endl << "Write BlockIP format" << endl;
//  bip.write_BlockIP_format("SCDual");
//  cout << "Read  BlockIP format" << endl;
//  bip.read_BlockIP_format("SCDualV.dat");

 // set some options
//  bip.set_show_specrad(true); // compute and show estimation of spectral radius
//  bip.set_type_direction(BlockIP::SECOND_ORDER);// computes predictor-corrector direction with PCG+Cholesky
//  bip.set_type_comp_dy(BlockIP::FULL_CHOL); // solve normal equation with Full Cholesky (not PCG+Cholesky)

// data of the problem
  cout << "BIPnumConst = " << bip.get_km() << endl; //Get the number of constraints without linking constraints
  cout << "BIPnumVaraibles = " << bip.get_kn() << endl;//Get the number of variables without linking constraints
  cout << "BIPnumLinking = " << bip.get_l_link() << endl; //Get the number of linking constraints.
  cout << "numConstOrig = " << bip.get_num_cons() << endl; //Get the number of constraints of the original
 
//solve
 t0= clock();
  cout << "Solve Problem *****************+ "<<endl; 
//  bip.minimize(); // solve problem
 t1= clock();

#ifdef OPENMP
    cout << "Elapsed OpenMP wall clock time: " << bip.get_wclock_time() << endl;
#endif

  cout << "Optimization CPU time: " << (double) (t1-t0)/CLOCKS_PER_SEC << " seconds" << endl;
  cout << "Total IPit= " << bip.get_it() << endl;
  cout << "Total CGit= " << bip.get_cgit() << endl;
  cout << "Primal Objetive = " << bip.get_fobj() << endl;
  cout << "Dual objetive = " << bip.get_dobj() << endl;

// t1= clock();


delete[] iN1;
delete[] jN1;
delete[] aN1;
delete[] iN2y;
delete[] jN2y;
delete[] aN2y;
delete[] iN2x;
delete[] jN2x;
delete[] aN2x;
delete[] c1;
delete[] z1;
delete[] qd;
delete[] Qsim;

delete [] N;
delete [] L;

// delete Q
for(int b=0; b<numBlocks; b++){ 
 delete[] Q[b];
}
 delete[] Q;

// delete D
for(int b=0; b<numBlocks; b++){ 
 delete[] D[b];
}
 delete[] D;

  return 0;

}

void createBalancePfacilityDual(int supplyN, int Pfacility, int ClientN, int *iN1, int *jN1, int *aN1, int numVarx){
  int rr=1, aux1i=0, aux1j=0;
	for(int k=0; k<(numVarx);k++){ 
		if(k<(supplyN*Pfacility)){ 
			jN1[k]=aux1i;
			iN1[k]=aux1j;
			aN1[k]=1;
			aux1j=aux1j+Pfacility;
			if(k==((supplyN*rr)-1)){
				aux1i++;
				aux1j=rr;
				rr++;
			}
		}else{                       
			if(k==(supplyN*Pfacility)){ 
				aux1i=0;
				rr=1;	
			}
			jN1[k]=aux1i;
			iN1[k]=k;
			aN1[k]=-1;
			if(k==supplyN*Pfacility+(ClientN*rr)-1){
				aux1i++;
				rr++;
			}
		}//else
	}//for
}//void

void createDemandClientNDual(int supplyN, int Pfacility, int ClientN, int *iN1, int *jN1, int *aN1, int numVarx, int numVarzS1){
    int rr=1, aux1i=Pfacility,  aux2i=Pfacility, aux3i=Pfacility; 
    int aux1j=supplyN*Pfacility, aux2j=numVarx;
	for(int k=numVarx; k<numVarx+(Pfacility*ClientN+numVarzS1);k++){ 
		if(k<numVarx+Pfacility*ClientN){
			jN1[k]=aux1i;
			iN1[k]=aux1j;
			aN1[k]=1;
			aux1j=aux1j+ClientN;
			if(k==(numVarx+(Pfacility*rr)-1)){
				aux1i++;
				aux1j=rr+supplyN*Pfacility;
				rr++;
			}
		}else{
			if(k<numVarx+Pfacility*ClientN+ClientN){
			jN1[k]=aux2i;
			iN1[k]=aux2j;
			aN1[k]=1;
				aux2i++;
				aux2j++;
			}else{ //***no enter (for Primal slacks of z)
				jN1[k]=aux3i;
				iN1[k]=aux2j;
				aN1[k]=-1;
				aux3i++;
				aux2j++;
			}//esle
		}//else
	}//for
}//void

void createCapacitySPyDual(int *iN2y, int *jN2y, int *aN2y, int numVary){
	for(int k=0; k<(numVary);k++){ 
		jN2y[k]=k;
		iN2y[k]=k;
		aN2y[k]=(rand() % 100 + 250);
	}
}

void createCapacitySPxHDual(int supplyN, int Pfacility, int ClientN, int *iN2x, int *jN2x, int *aN2x, int numVarx, int nozeroN2x){
   int rr=1, r=1, aux1i=Pfacility+ClientN, aux2i=Pfacility+ClientN+supplyN, aux3i=0;
	for(int k=0; k<nozeroN2x;k++){
		aN2x[k]=1; 
		if(k<(numVarx)){ 					
			iN2x[k]=k;
		}
		if(k<(supplyN*Pfacility)){
			jN2x[k]=aux1i;
			if(k==((Pfacility*rr)-1)){
				aux1i++;
				rr++;
			}
		}else{
			if(k<numVarx){ 
				jN2x[k]=aux2i;
				if(k==(supplyN*Pfacility)+((ClientN*r)-1)){
					aux2i++;
					r++;
				}
			}
		}//else
	}//for
}//void

void  createInvestmentSP(double *c1, int numVary){
	for(int k=0; k<(numVary);k++){ 
		c1[k]=(rand() % 100 + 250)*1000;
	}   
}//void

void  createShortageC(int ClientN, double *z1){
	for(int k=0; k<(ClientN);k++){ 
		z1[k]=(10+rand()%(16-10))*1000;
	}   
}//void

void  createTransportationSPyPC(int supplyN, int Pfacility, double *qd, int numVarx){
  int n1[numVarx];
  double n2[numVarx];
	for(int k=0; k<numVarx;k++){
		n1[k] =(rand()%11); 
		n2[k] =(double)n1[k]/10; 
		if(k<supplyN*Pfacility){ 
			qd[k]=(60+rand()%(211-60))+n2[k]; 
		}else{
			qd[k]=(200+rand()%(701-200))+n2[k]; 			
		}//else
	} //for
}//void

void createDualCost(int supplyN, int Pfacility, int ClientN, int numBlocks, double *c1, double *z1, double *qd, double **Q, int numVary, int numVarx, int numVarz, int numVarBlock){// Q cost primal
//for blocks
int rr = 1; //por bloque 
for(int b=0; b<numBlocks; b++){ 
 //Unit production cost S U P 
	double Upc[Pfacility] ; //unit production cost for every node Pfacility 
	for (int pp = 0; pp < Pfacility; ++pp ){
		Upc[pp] = (rand() % 250 + 550);  
	}//for Pfacility
// for check Upc
//	for (int pp = 0; pp < Pfacility; ++pp ){
//		 cout<<" Upc["<<pp<<"]= "<<Upc[pp]<<endl;
//	}//for Pfacility
 double qp[numVarx];
	int kk = 0; // index per Pfacility
	int kkp = 1;//index per SupplyN
	for (int i = 0; i < numVarx; ++i){ 
		if (i < Pfacility*kkp ){
			qp[i]= Upc[kk];
			kk++;
			if(kk == Pfacility){
				kk=0;
				kkp++;
			}
			if(kkp > supplyN){
				kkp=0;
			}
		}else{
			qp[i]=0;
		}
	}//for 
// for check Upc
//	for (int i = 0; i < numVarx; i++ ){
//		 cout<<" qp["<<i<<"]= "<<qp[i]<<endl;
//	}

  //cost per arc
  double c[(numVarBlock)];
  int p = 0;  //index inside qd
  int z = 0; //index per ClientN penalization
  for (int i = 0 ; i < numVarBlock; ++i ) { 
    if(i<numVary){  
		if (rr==1){ 
			c[i] = c1[i];
		}else{
			c[i] = 0; 
		}//else 
	}
	else{
		if(i<(numVary + numVarx)){   
			if (rr==1){ 
				c[i]=1000; //production cost per arc = 0 
			}else{
				c[i] = 0; 
			}//else 
		}
		else{
			if(i<(numVary+(2*numVarx))){ 	
				c[i] = qd[p]+qp[p];
				p++;
				if(p ==numVarx) p=0;
			}else{
				if(i<(numVary +(2*numVarx) + numVarz)){  
					if(z<ClientN){
						c[i] = z1[z];
						z++;
					}else{
						c[i]=0; 
					}//else
					if(z == numVarz) z=0;
				}//if
			}//else
		}//else 
	}//else 
   }//for
 rr++;
 for (int i = 0; i < numVarBlock; ++i) { 
     Q[b][i] = c[i];
     }
 } //for
}//void

void createDemandD(int ClientN, int numBlocks, double **D){ // right hand side b -demand per ClientN 
 for(int b=0; b<numBlocks; b++){ 
	for (int i = 0; i < ClientN; ++i) { 
		D[b][i] = (rand() % 250 + 550);
	}
 }//for
}//void

